#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "xmgargs.h"
#include "xmgerr.h"

char	DisplayName[1024];
int		Frames;
int		FramesPerSecond;
int		Help;
int		Verbose;
char	TmpFile[1024];
char	OutputFile[1024];
int		UseMITSHM;
char	ParamFile[1024];
int		Delay;
int		FramesPerMinute;

void parseargs(int argc,char **argv)
{
	int i;
	char tmp[255];
	char *error;
	
	DisplayName[0] = '\0';
	strcpy(TmpFile,"/tmp/xmgtmp.$$$");
	strcpy(OutputFile,"./xmgout.mpg");
	strcpy(ParamFile,"xmg.param");
	Frames = 10;
	Help = 0;
	Verbose = 1;
	Delay = 1000; /* 1 frame per second */
	
	i = 1;
	while(i<argc) {
		if(!strcmp(argv[i],"-display")) {
			if(i<argc-1) {
				strcpy(DisplayName,argv[i+1]);
				i += 2;
			} else {
				Help = 1;
				i++;
			}
		} else
		if(!strcmp(argv[i],"-frames")) {
			if(i<argc-1) {
				Frames = strtol(argv[i+1],&error,10);
				if(!(*error=='\0')) 
					Fatal_Error("Incorrect number of frames");
				i += 2;
			} else {
				Help = 1;
				i++;
			}
		} else
		if(!strcmp(argv[i],"-fps")) {
			if(i<argc-1) {
				FramesPerSecond = strtol(argv[i+1],&error,10);
				if(!(*error=='\0')) 
					Fatal_Error("Incorrect number of fps");
				Delay = 1000000/FramesPerSecond;
				i += 2;
			} else {
				Help = 1;
				i++;
			}
		} else
		if(!strcmp(argv[i],"-fpm")) {
			if(i<argc-1) {
				FramesPerMinute = strtol(argv[i+1],&error,10);
				if(!(*error=='\0')) 
					Fatal_Error("Incorrect number of fpm");
				Delay = 60000000/FramesPerMinute;
				i += 2;
			} else {
				Help = 1;
				i++;
			}
		} else
		if(!strcmp(argv[i],"-help")) {
			Help = 1;
			i++;
		} else
		if(!strcmp(argv[i],"-h")) {
			Help = 1;
			i++;
		} else
		if(!strcmp(argv[i],"-tmp")) {
			if(i<argc-1) {
				strcpy(TmpFile,argv[i+1]);
				i += 2;
			} else {
				Help = 1;
				i++;
			}
		} else
		if(!strcmp(argv[i],"-param")) {
			if(i<argc-1) {
				strcpy(ParamFile,argv[i+1]);
				i += 2;
			} else {
				Help = 1;
				i++;
			}
		} else
		if(!strcmp(argv[i],"-output")) {
			if(i<argc-1) {
				strcpy(OutputFile,argv[i+1]);
				i += 2;
			} else {
				Help = 1;
				i++;
			}
		} else
		if(!strcmp(argv[i],"-terse")) {
			Verbose = 0;
			i++;
		} else {
			fprintf(stderr,"Unknown option %s\n",argv[i]);
			Help = 1;
			i++;
		}
	}
}	
	
void writeparamfile()
{
	FILE *fp;

	fp = fopen("xmg.param","wb");
	fprintf(fp,"# Default parameter file generated by XMG\n");
	fprintf(fp,"# Read the man page for specific switches\n\n");
	fprintf(fp,"PATTERN		IBBPBBPBBPBBPBB\n");
	fprintf(fp,"GOP_SIZE	30\n");
	fprintf(fp,"SLICES_PER_FRAME	1\n");
	fprintf(fp,"PIXEL		HALF\n");
	fprintf(fp,"RANGE		10\n");
	fprintf(fp,"PSEARCH_ALG	LOGARITHMIC\n");
	fprintf(fp,"BSEARCH_ALG	CROSS2\n");
	fprintf(fp,"IQSCALE		8\n");
	fprintf(fp,"PQSCALE		10\n");
	fprintf(fp,"BQSCALE		25\n");
	fprintf(fp,"REFERENCE_FRAME	ORIGINAL\n");
	fclose(fp);
}			